<link rel="import" href="/extern/bower_components/paper-input/paper-input.html">
<link rel="import" href="/extern/bower_components/iron-ajax/iron-ajax.html">
<link rel="import" href="/ts/common-elements/iron-flex-layout-attributes/iron-flex-layout-attributes.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">
<link rel="import" href="/ts/common-elements/command-input/command-input.html">
<link rel="import" href="/extern/bower_components/juicy-jsoneditor/src/juicy-jsoneditor.html">
<link rel="import" href="/extern/bower_components/iron-a11y-keys/iron-a11y-keys.html">

<dom-module id="ts-command">
    <template>
        <style include="iron-flex-layout-attributes"></style>
        <style include="reset-css"></style>
        <iron-a11y-keys target="[[_target]]"
                        keys="enter"
                        on-keys-pressed="onEnter"></iron-a11y-keys>
        <style>
paper-material{padding:10px}form{margin-bottom:30px}[wrap] command-input{margin:10px;width:260px}pre[warning]{color:red}juicy-jsoneditor{margin-top:1em}#result>p{color:var(--paper-grey-600, gray)}#result{overflow:auto}

</style>
        <iron-ajax id="ajax" url="" on-response="_handleResponse"></iron-ajax>
        <h2>{{name}}</h2>
        <div horizontal layout wrap>
            <template is="dom-repeat" items="{{parameters}}">
                <command-input id="[[_toId(item.variable)]]"
                               name="[[item.variable]]"
                               value="[[item.default]]"
                               type="[[item.type]]"></command-input>
            </template>
        </div>
        <paper-button raised on-click="_submit">Submit</paper-button>
        <h2>Result</h2>
        <auto-update id="autoupdate" callback="command-refresh" on-data-changed="_handleAutoupdate" no-refresh handle-as="text"></auto-update>
        <div id="result">
          <p>Awaiting the click of the 'submit' button...</p>
        </div>
    </template>
    <script>
Polymer({is:"ts-command",properties:{name:{type:String,value:""},parameters:{type:Array,value:function(){return[]}},_target:{type:Object,value:function(){return this}}},onEnter:function(){this._submit()},_getLabel:function(name,variabletype){return name+" ("+variabletype+")"},_getValidationPattern:function(variabletype){switch(variabletype){case"bool":return"^(0|1|true|false|True|False)$";case"int":return"[0-9]*";case"unsigned int":return"[0-9]*";case"long":return"[0-9]*";case"unsigned long":return"[0-9]*";case"double":return"^[-+]?[0-9]*.?[0-9]+([eE][-+]?[0-9]+)?$";case"string":return".*";default:console.warn("<ts-command>: variable type '"+variabletype+"' is unknown, consider developing a validation pattern for it")}},_submit:function(event,detail,sender){for(this.$.ajax.handleAs="text",i=0;i<this.parameters.length;i++)this.$.ajax.params[this.parameters[i].variable]=this.$$("[id='"+this._toId(this.parameters[i].variable+"']")).value;this.$.ajax.params._id_="ts-command-submit",this.$.ajax.params["ts-command-submit"]="",this.$.ajax.params._eventType_="OnSubmit",this.$.ajax.generateRequest()},_isJSON:function(data){try{JSON.parse(data.replace("<pre>","").replace("</pre>",""))}catch(e){return!1}return!0},_handleResponse:function(e){this._setResult(e.detail.response),this.$.autoupdate.set("noRefresh",!1)},_handleAutoupdate:function(e){var data=this.$.autoupdate.data;data&&""!=data&&this._setResult(data)},_setResult:function(data){var resultbox=Polymer.dom(this.$.result);if(this._isJSON(data)){var json=JSON.parse(data.replace("<pre>","").replace("</pre>","")),curreneditor=resultbox.querySelector("juicy-jsoneditor");if(!curreneditor||JSON.stringify(json)!=JSON.stringify(curreneditor.get())){resultbox.innerHTML="";var juicyjson=document.createElement("juicy-jsoneditor");juicyjson.set("json",json),resultbox.appendChild(juicyjson),juicyjson.editor&&juicyjson.editor.expandAll()}}else resultbox.innerHTML=data},_toId:function(name){return name.replace(" ","_")}});
</script>
</dom-module>
